/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,o){var n,i=arguments.length,s=3>i?t:null===o?o=Object.getOwnPropertyDescriptor(t,r):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,o);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(s=(3>i?n(s):i>3?n(t,r,s):n(t,r))||s);return i>3&&s&&Object.defineProperty(t,r,s),s},__param=this&&this.__param||function(e,t){return function(r,o){t(r,o,e)}};define("vs/workbench/parts/terminal/electron-browser/terminalPanel",["require","exports","child_process","term.js","vs/base/common/lifecycle","os","path","vs/base/common/uri","vs/base/browser/dom","vs/base/common/platform","vs/platform/theme/common/themes","vs/base/common/winjs.base","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/workbench/services/themes/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/parts/terminal/electron-browser/terminal","vs/workbench/browser/panel","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/scrollbar/scrollableElementOptions"],function(e,t,r,o,n,i,s,a,c,l,m,p,f,h,u,d,v,b,y,g){"use strict";var w=8,_=18,D={"hc-black":["#000000","#cd0000","#00cd00","#cdcd00","#0000ee","#cd00cd","#00cdcd","#e5e5e5","#7f7f7f","#ff0000","#00ff00","#ffff00","#5c5cff","#ff00ff","#00ffff","#ffffff"],vs:["#000000","#cd3131","#008000","#949800","#0451a5","#bc05bc","#0598bc","#555555","#666666","#cd3131","#00aa00","#b5ba00","#0451a5","#bc05bc","#0598bc","#a5a5a5"],"vs-dark":["#000000","#cd3131","#09885a","#e5e510","#2472c8","#bc3fbc","#11a8cd","#e5e5e5","#666666","#f14c4c","#17a773","#f5f543","#3b8eea","#d670d6","#29b8db","#e5e5e5"]},T=function(t){function b(e,r,o,n,i){t.call(this,v.TERMINAL_PANEL_ID,r),this.configurationService=e,this.contextService=o,this.terminalService=n,this.themeService=i,this.toDispose=[]}return __extends(b,t),b.prototype.layout=function(e){var t=Math.floor(this.parentDomElement.offsetWidth/w),r=Math.floor(this.parentDomElement.offsetHeight/_);this.terminal&&this.terminal.resize(t,r),this.ptyProcess.connected&&this.ptyProcess.send({event:"resize",cols:t,rows:r})},b.prototype.create=function(e){return t.prototype.create.call(this,e),this.parentDomElement=e.getHTMLElement(),this.createTerminal()},b.prototype.setVisible=function(e){var r=this;return e&&null===this.terminal?t.prototype.setVisible.call(this,e).then(function(){return r.createTerminal()}):t.prototype.setVisible.call(this,e)},b.prototype.cloneEnv=function(){var e=Object.create(null);return Object.keys(process.env).forEach(function(t){e[t]=process.env[t]}),e},b.prototype.createTerminalProcess=function(){var t=this.cloneEnv();return t.PTYSHELL=this.getShell(),t.PTYCWD=this.contextService.getWorkspace()?this.contextService.getWorkspace().resource.fsPath:i.homedir(),r.fork("./terminalProcess",[],{env:t,cwd:a["default"].parse(s.dirname(e.toUrl("./terminalProcess"))).fsPath})},b.prototype.createTerminal=function(){var e=this;return new p.TPromise(function(t){e.parentDomElement.innerHTML="",e.ptyProcess=e.createTerminalProcess(),e.terminalDomElement=document.createElement("div"),e.parentDomElement.classList.add("integrated-terminal");var r=new y.DomScrollableElement(e.terminalDomElement,{canUseTranslate3d:!1,horizontal:g.ScrollbarVisibility.Hidden,vertical:g.ScrollbarVisibility.Auto});e.toDispose.push(r),e.terminal=o({cursorBlink:!1}),e.ptyProcess.on("message",function(t){e.terminal.write(t)}),e.terminal.on("data",function(t){return e.ptyProcess.send({event:"input",data:t}),!1}),e.ptyProcess.on("exit",function(t){e.toDispose=n.dispose(e.toDispose),e.terminal.destroy(),e.terminal=null,0!==t&&console.error("Integrated terminal exited with code "+t),e.terminalService.toggle()}),e.toDispose.push(c.addDisposableListener(e.parentDomElement,"mousedown",function(t){2===t.which&&l.isLinux&&e.focusTerminal(!0)})),e.toDispose.push(c.addDisposableListener(e.parentDomElement,"mouseup",function(t){3!==t.which&&e.focusTerminal()})),e.toDispose.push(e.themeService.onDidThemeChange(function(t){e.setTerminalTheme(t)})),e.terminal.open(e.terminalDomElement),e.parentDomElement.appendChild(r.getDomNode());var i=e.configurationService.getConfiguration();e.terminalDomElement.style.fontFamily=i.terminal.integrated.fontFamily,e.setTerminalTheme(e.themeService.getTheme()),t(void 0)})},b.prototype.setTerminalTheme=function(e){if(this.terminal){var t=m.getBaseThemeId(e);this.terminal.colors=D[t],this.terminal.refresh(0,this.terminal.rows)}},b.prototype.focus=function(){this.focusTerminal(!0)},b.prototype.focusTerminal=function(e){if(this.terminal){var t=window.getSelection().toString();t&&!e||(this.terminal.focus(),this.terminal._textarea&&this.terminal._textarea.focus())}},b.prototype.getShell=function(){var e=this.configurationService.getConfiguration();return l.isWindows?e.terminal.integrated.shell.windows:l.isMacintosh?e.terminal.integrated.shell.osx:e.terminal.integrated.shell.linux},b.prototype.dispose=function(){this.toDispose=n.dispose(this.toDispose),this.terminal.destroy(),this.ptyProcess.kill(),t.prototype.dispose.call(this)},b=__decorate([__param(0,f.IConfigurationService),__param(1,h.ITelemetryService),__param(2,d.IWorkspaceContextService),__param(3,v.ITerminalService),__param(4,u.IThemeService)],b)}(b.Panel);t.TerminalPanel=T});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/809e7b30e928e0c430141b3e6abf1f63aaf55589/vs/workbench/parts/terminal/electron-browser/terminalPanel.js.map
